; CLASSAPPLICATIONA.PRO
;
; This is the main menu module for the multi-module application.  It will launch
; both object widget programs and conventional-style widget programs.
;
; Written by R.M. Dimeo (11/26/02)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro caCleanup,tlb
widget_control,tlb,get_uvalue = pState
ptr_free,pState
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro caEvent,event
uname = widget_info(event.id,/uname)
case uname of
'QUIT':		widget_control,event.top,/destroy
'APP1':	begin
		widget_control,event.top,get_uvalue = pState
		xcurveChange,group_leader = event.top,count = (*pState).wCounter
		(*pState).wCounter = (*pState).wCounter + 1
	end
'APP2':	begin
		widget_control,event.top,get_uvalue = pState
		o = obj_new('ocurveChange',group_leader = event.top, $
		  count = (*pState).oCounter)
		(*pState).oCounter = (*pState).oCounter + 1
	end
else:
endcase
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro classApplicationA
; Widget definition module
tlb = widget_base(/col,title = 'Class Application')
void = widget_button(tlb,value = 'Conventional Widget App',uname = 'APP1')
void = widget_button(tlb,value = 'Widget Object App',uname = 'APP2')
void = widget_button(tlb,value = 'QUIT',uname = 'QUIT')

widget_control,tlb,/realize
; Create a couple of counters for the conventional widget app and the
; object widget app.
state = {wCounter:0, oCounter:0}
widget_control,tlb,set_uvalue = ptr_new(state,/no_copy)

xmanager,'CA',tlb,event_handler = 'caEvent',cleanup = 'caCleanup',/no_block
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
