; NMOCURVE.PRO
;
; Non-modal widget dialog for the object program called ocurveChange.
;
; Written by R.M. Dimeo (11/25/02)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro nmoCurveCleanup,tlb
widget_control,tlb,get_uvalue = pInfo
ptr_free,pInfo
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro nmoCurveEvent,event
uname = widget_info(event.id,/uname)
case uname of
'CURVEGROUP':	$
	begin
	widget_control,event.top,get_uvalue = pInfo
	if (*pInfo).group_leader ne 0L then begin
  	  widget_control,event.id,get_value = index
	  widget_control,(*pInfo).group_leader,get_uvalue = object
	  if index eq 0 then funcName = 'SIN' else funcName = 'COS'
	  object->calcFun,funcName
	endif
	end
'DONE':			$
	begin
	widget_control,event.top,/destroy
	end
else:
endcase
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro nmoCurve,group_leader = group_leader
if n_elements(group_leader) eq 0 then begin
  group_leader = 0L
  floating = 0
endif else begin
  floating = 1
endelse
tlb = widget_base(group_leader = group_leader,/col,floating = floating)
; The next thing to check is if there is an instance of this program running
; already associated with the calling program.  If so then proceed no further.
registerName = 'nmo'+strtrim(string(group_leader),2)
if xregistered(registerName) then return
curveType = ['sin(x)','cos(x)']
curveGroup = cw_bgroup(tlb, curveType, /col, /exclusive,$
         label_top='Curve Type',/no_release,$
         frame=1,set_value=0,/return_index,uname = 'CURVEGROUP')
void = widget_button(tlb,value = 'DONE',uname = 'DONE')
widget_control,tlb,/realize

info = {group_leader:group_leader}

pInfo = ptr_new(info,/no_copy)
widget_control,tlb,set_uvalue = pInfo
xmanager,registerName,tlb,event_handler = 'nmoCurveEvent', $
  cleanup = 'nmoCurveCleanup'
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;