; XCURVECHANGE_A.PRO
;
; This widget program demonstrates the use of a modal dialog
; widget utility.
;
; Written by R.M. Dimeo (11/25/02)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro xccCleanup,tlb
widget_control,tlb,get_uvalue = pState
wdelete,(*pState).winPix
ptr_free,(*pState).dataPtr
ptr_free,pState
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro xccQuit,event
widget_control,event.top,/destroy
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro xccDisplayCurve,event
widget_control,event.top,get_uvalue = pState
data = *(*pState).dataPtr
x = (*(*pState).dataPtr)[*,0]
y = (*(*pState).dataPtr)[*,1]
wset,(*pState).winPix
plot,x,y,xrange = [min(x),max(x)],/xsty
wset,(*pState).winVis
device,copy = [0,0,!d.x_size,!d.y_size,0,0,(*pState).winPix]
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro xccModalLaunch,event
widget_control,event.top,get_uvalue = pState
data = *(*pState).dataPtr
x = data[*,0]
; The call below freezes this application up until the DONE button in the
; modal dialog is pressed.
newData = mCurveChange(parent = event.top,x)
; Get here if the DONE button was pressed.
*(*pState).dataPtr = newData
xccDisplayCurve,event
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro xcurveChange_a
; Widget definition module
device,decomposed = 0
loadct,0,/silent
thisTitle = 'Conventional widget implementation'

tlb = widget_base(/col,/tlb_frame_attr, $
    mbar = bar,title = thisTitle)

filemenu = widget_button(bar,value = 'FILE',/menu)
void = widget_button(filemenu,value = 'QUIT',event_pro = 'xccQuit')
xsize = 400 & ysize = 400

win = widget_draw(tlb,xsize = xsize,ysize = ysize)
rowBase = widget_base(tlb,/row,/align_center)
void = widget_button(rowBase,value = 'MODAL DIALOG',event_pro = 'xccModalLaunch')
widget_control,tlb,/realize
; create a sin function to display
n = 50
x = (2.0*!pi/(n-1.))*findgen(n)
y = sin(x)
data = [[x],[y]]

widget_control,win,get_value = winVis
window,/free,/pixmap,xsize = xsize,ysize = ysize
winPix = !d.window

state = {	win:win,		$
			winPix:winPix,	$
			winVis:winVis,	$
			dataPtr:ptr_new(data,/no_copy)		$
		}
pState = ptr_new(state,/no_copy)
widget_control,tlb,set_uvalue = pState

; Display curve
pseudoEvent = {event,id:win,top:tlb,handler:0L}
xccDisplayCurve,pseudoEvent

xmanager,'xc',tlb,/no_block,cleanup = 'xccCleanup', $
  event_handler = 'xccEvent'
end
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
